package pb.ir.irdata;


import java.util.Iterator;
import java.util.Enumeration;
import java.util.TreeMap;

import pb.util.OrdList;


public class Manuf {
	String name;
	SignalParams signal = new SignalParams();
	private OrdList devList = new OrdList();
	String module = null;

	public Enumeration getDeviceList() {
		return devList.values();
	}

	public Enumeration getFuncList(String deviceName) {
		IRDevice d = (IRDevice)(devList.get(deviceName));
		if (d == null)
			return null;
		return d.getFuncListx();
	}

	public IRFunction getFunc(String deviceName, String funcName) {
		IRDevice d = (IRDevice)(devList.get(deviceName));
		if (d == null)
			return null;
		IRFunction f = (IRFunction)(d.getFunc(funcName));
		return f;
	}

	public void build() {
	}

	public void addDevice(String dName) {
		if (devList.get(dName) == null) {
			devList.put(dName, new IRDevice(dName));
		}
	}

	public void addDevice(IRDevice dev) {
		devList.put(dev.getName(), dev);
	}

    public IRDevice getDevice(String dName) {
    	return (IRDevice)(devList.get(dName));
    }

    public IRDevice getDevice(long code) {
    	for (Enumeration it = getDeviceList(); it.hasMoreElements(); ) {
        	IRDevice d = (IRDevice)(it.nextElement());
            IRFunction f = d.getFunction(code);
            if (f != null)
            	return d;
        }

        return null;
    }

    public String getName() {
    	return name;
    }
}
