package pb.ir.ui;


import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.util.Iterator;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JComboBox;

import pb.ir.irdata.IRDevice;
import pb.ir.irdata.IRFunction;
import pb.ir.irdata.Manuf;


public class DialogDevFunc {
	private JDialog dialog = new JDialog((Frame)null, "Code Details", true);
    JComboBox cbDev, cbFunc;
    Manuf m;
    boolean okFlag = false;

	public DialogDevFunc() {
    	JPanel entry = new JPanel();
        entry.setLayout(new GridLayout(0, 2));
        entry.add(new JLabel("Device"));
        entry.add(cbDev = new JComboBox());

        entry.add(new JLabel("Function"));
        entry.add(cbFunc = new JComboBox());

        cbDev.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String dName = (String)cbDev.getSelectedItem();

                if ((dName == null) || dName.equals("")) {
                    if (cbFunc != null) {
                    	cbFunc.removeAllItems();
                    }
                }
                else {
	                cbFunc.removeAllItems();
    	            cbFunc.addItem("");
                    Enumeration it = m.getFuncList(dName);
                    if (it != null) {
				        for (; it.hasMoreElements(); ) {
	                        IRFunction f = (IRFunction)(it.nextElement());
	        				cbFunc.addItem(f.name);
			        	}
                    }
                }
			}
        });

        cbDev.setEditable(true);
        cbFunc.setEditable(true);

        JPanel action = new JPanel();
        JButton okBtn = new JButton("OK");
        action.add(okBtn);
        okBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
            	// Validate code?
            	okFlag = true;
                dispose();
            }
        });

        JButton cancelBtn = new JButton("Cancel");
        action.add(cancelBtn);
        cancelBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
            	// Validate code?
            	okFlag = false;
                dispose();
            }
        });

		dialog.addWindowListener(new WindowAdapter() {
		    public void windowClosing(WindowEvent we) {
            	okFlag = false;
                dispose();
		    }
		});

        dialog.getContentPane().add(entry, BorderLayout.CENTER);
        dialog.getContentPane().add(action, BorderLayout.SOUTH);
        dialog.pack();
    }

    private void setList(Manuf manuf) {
    	m = manuf;

    	cbDev.removeAllItems();
    	cbFunc.removeAllItems();
        cbDev.addItem("");

        if (manuf != null) {
        	Enumeration it = manuf.getDeviceList();
	    	for ( ; it.hasMoreElements(); ) {
				IRDevice dev = (IRDevice)(it.nextElement());
        	    cbDev.addItem(dev.getName());
	        }
        }
    }

    public void show(Manuf manuf) {
    	setList(manuf);
        okFlag = false;
    	dialog.show();
    }

    public void dispose() {
    	dialog.dispose();
    }

    public boolean isValid() {
    	if (!okFlag)
        	return false;
        String dName = getDevice();
        if (dName == null || dName.length() == 0)
        	return false;
        String fName = getFunction();
        if (fName == null || fName.length() == 0)
        	return false;

        return true;
    }

    public String getDevice() {
    	return (String)(cbDev.getSelectedItem());
    }

    public String getFunction() {
    	return (String)(cbFunc.getSelectedItem());
    }

    public static void main(String[] args) {
    	DialogDevFunc dialog = new DialogDevFunc(); 
    	dialog.show(null);
    }
}